package tech.nevets.deepj;

import org.json.JSONArray;
import org.json.JSONObject;
import java.io.IOException;
import java.net.URI;
import java.net.URLEncoder;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.nio.charset.StandardCharsets;

import java.io.IOException;

public class Translator {

    //TODO Once I get home I gotta see if this works
    //NOTE: I'm stupid and did this during ELA

    private final String authKey;
    Request r = new Request();

    public Translator(String authKey) {
        this.authKey = authKey;
    }
    public String translate(Enum<Languages> lang, String sourceMessage) {
        String response = "Error processing request";
        try {
            response = r.get(authKey, lang, sourceMessage);
        } catch (IOException | InterruptedException e) {
            System.out.println("Error processing request");
            e.printStackTrace();
        }

        String message = "Error Processing Request";

        JSONObject jo = new JSONObject(response);
        JSONArray ja = jo.getJSONArray("translations");

        for (int i = 0; i < ja.length(); i++) {
            JSONObject joo = ja.getJSONObject(i);
            message = joo.getString("text");
        }

        return message;
    }
}

private class Request {
    public Request() {
    }

    public String get(String authKey, Enum<Languages> langEnum, String message) throws IOException, InterruptedException {
        String encodedAuthKey = URLEncoder.encode(authKey, StandardCharsets.UTF_8);

        String lang;
        lang = langEnum.toString();

        if (langEnum == Languages.ENUS) {
            lang = "EN-US";
        } else if (langEnum == Languages.ENGB) {
            lang = "EN-GB";
        } else if (langEnum == Languages.PTBR) {
            lang = "PT-BR";
        } else if (langEnum == Languages.PTPT) {
            lang = "PT-PT";
        }

        String encodedMessage = URLEncoder.encode(message, StandardCharsets.UTF_8);

        HttpClient client = HttpClient.newHttpClient();
        HttpRequest request = HttpRequest.newBuilder()
                .GET()
                .header("Accept","*/*")
                .header("Content-Type", "application/x-www-form-urlencoded")
                .uri(URI.create("https://api-free.deepl.com/v2/translate?auth_key=" + encodedAuthKey + "&target_lang=" + lang + "&text=" + encodedMessage))
                .build();
        HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());

        String data = response.body();

        return data;
        //wait for imports
    }
}

public static enum Languages {
    BG,
    CS,
    DA,
    DE,
    EL,
    ENGB,
    ENUS,
    ES,
    ET,
    FI,
    FR,
    HU,
    IT,
    JA,
    LT,
    LV,
    NL,
    PL,
    PTBR,
    PTPT,
    RO,
    RU,
    SK,
    SL,
    SV,
    ZH
}

